# Advanced Guides

- [Advanced Guides - Overview](https://docs.bluebubbles.app/server/advanced/advanced-guides-overview.md): Here you will find more advanced guides for using BlueBubbles
- [Generating an SSL Certificate using CertBot](https://docs.bluebubbles.app/server/advanced/generating-an-ssl-certificate-using-certbot.md): Learn how you can generate an SSL Certificate using CertBot for BlueBubbles. This is especially useful for dynamic DNS setups.
- [Disabling SIP on Unofficial Macs for the Private API](https://docs.bluebubbles.app/server/advanced/disabling-sip-on-unofficial-macs-for-the-private-api.md)
- [Registering a Phone Number with your iMessage Account](https://docs.bluebubbles.app/server/advanced/registering-a-phone-number-with-your-imessage-account.md): This page will guide you on how you can link your phone number with your iMessage account. By default, BlueBubbles will use your iCloud email to send iMessages.
- [macOS Virtualization](https://docs.bluebubbles.app/server/advanced/macos-virtualization.md): Here, you will find guides on virtualizing macOS, whether that be in a virtual machine, or in a docker container.
- [Running a macOS VM](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-a-macos-vm.md)
- [Deploying macOS in VMWare on Windows (Full Guide)](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-a-macos-vm/deploying-macos-in-vmware-on-windows-full-guide.md)
- [Enabling iMessage in a VM](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-a-macos-vm/enabling-imessage-in-a-vm.md): How to enable iMessage after successfully creating an unofficial Mac device
- [External Guides](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-a-macos-vm/external-guides.md)
- [Running BlueBubbles in Docker-OSX](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-bluebubbles-in-docker-osx.md): This tutorial will show you how you can setup BlueBubbles in a Docker container, within a Linux host.
- [Configuring BlueBubbles as a Service](https://docs.bluebubbles.app/server/advanced/macos-virtualization/running-bluebubbles-in-docker-osx/configuring-bluebubbles-as-a-service.md): This guide will show you how to setup the BlueBubbles Docker container to run as a service on your Linux host. This is to make sure that the host starts up when your Linux host restarts.
- [BYO Proxy Service Guides](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides.md): Here you will find child guides for setting up BlueBubbles with a BYO (Bring Your Own) Proxy Service (Dynamic DNS).
- [Cloudflare with a Custom Domain](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/cloudflare-with-a-custom-domain.md)
- [Caddy & DuckDNS](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/caddy-and-duckdns.md): A way to get https when portforwarding with bluebubbles
- [Nginx Proxy Manager](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/nginx-proxy-manager.md): This guide will show you how to setup your own dynamic DNS using your own self-hosted server, running Nginx Proxy Manager
- [Nginx Manual Setup](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/nginx-manual-setup.md): If you want to perform a manual setup of Nginx, instead of using the Nginx Proxy Manager, here is a guide on how to do it. Big thanks to @JustBen in the BlueBubbles Discord, for putting this guide tog
- [Tailscale VPN Setup](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/tailscale-vpn-setup.md)
- [zrok Proxy Service](https://docs.bluebubbles.app/server/advanced/byo-proxy-service-guides/zrok-proxy.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bluebubbles.app/server/advanced.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
